Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util
Class Arrays

    java.lang.Object
      |
      +--java.util.Arrays

public class Arrays
extends Object

This class contains various methods for manipulating arrays (such as sorting and searching). It also contains a static factory that allows arrays to be viewed as lists.

The documentation for the sorting and searching methods contained in this class includes briefs description of the implementations. Such descriptions should be regarded as implementation notes, rather than parts of the specification. Implementors should feel free to substitute other algorithms, so long as the specification itself is adhered to. (For example, the algorithm used by `sort(Object[])` does not have to be a mergesort, but it does have to be stable.)

Since:
  1.2
See Also:
  `Comparable`, `Comparator`

Method Summary
`static List` | `asList(Object[] a)` Returns a fixed-size list backed by the specified array.
`static int` | `binarySearch(byte[] a, byte key)` Searches the specified array of bytes for the specified value using the binary search algorithm.
`static int` | `binarySearch(char[] a, char key)` Searches the specified array of chars for the specified value using the binary search algorithm.
`static int` | `binarySearch(double[] a, double key)` Searches the specified array of doubles for the specified value using the binary search algorithm.
`static int` | `binarySearch(float[] a, float key)` Searches the specified array of floats for the specified value using the binary search algorithm.
`static int` | `binarySearch(int[] a, int key)` Searches the specified array of ints for the specified value using the binary search algorithm.
`static int` | `binarySearch(long[] a, long key)` Searches the specified array of longs for the specified value using the binary search algorithm.
`static int` | `binarySearch(Object[] a, Object key)` Searches the specified array for the specified object using the binary search algorithm.
`static int` | `binarySearch(Object[] a, Object key, Comparator c)` Searches the specified array for the specified object using the binary search algorithm.
`static int` | `binarySearch(short[] a, short key)` Searches the specified array of shorts for the specified value using the binary search algorithm.
`static boolean` | `equals(boolean[] a, boolean[] a2)` Returns `true` if the two specified arrays of equals are equal to one another.
`static boolean` | `equals(byte[] a, byte[] a2)` Returns `true` if the two specified arrays of bytes are equal to one another.
`static boolean` | `equals(char[] a, char[] a2)` Returns `true` if the two specified arrays of chars are equal to one another.
`static boolean` | `equals(double[] a, double[] a2)` Returns `true` if the two specified arrays of doubles are equal to one another.
`static boolean` | `equals(float[] a, float[] a2)` Returns `true` if the two specified arrays of floats are equal to one another.
`static boolean` | `equals(int[] a, int[] a2)` Returns `true` if the two specified arrays of ints are equal to one another.
`static boolean` | `equals(long[] a, long[] a2)` Returns `true` if the two specified arrays of longs are equal to one another.
`static boolean` | `equals(Object[] a, Object[] a2)` Returns `true` if the two specified arrays of Objects are equal to one another.
`static boolean` | `equals(short[] a, short[] a2)` Returns `true` if the two specified arrays of shorts are equal to one another.
`static void` | `fill(boolean[] a, boolean val)` Assigns the specified boolean value to each element of the specified array of booleans.
`static void` | `fill(boolean[] a, int fromIndex, int toIndex, boolean val)` Assigns the specified boolean value to each element of the specified range of the specified array of booleans.
`static void` | `fill(byte[] a, byte val)` Assigns the specified byte value to each element of the specified array of bytes.
`static void` | `fill(byte[] a, int fromIndex, int toIndex, byte val)` Assigns the specified byte value to each element of the specified range of the specified array of bytes.
`static void` | `fill(char[] a, char val)` Assigns the specified char value to each element of the specified array of chars.
`static void` | `fill(char[] a, int fromIndex, int toIndex, char val)` Assigns the specified char value to each element of the specified range of the specified array of chars.
`static void` | `fill(double[] a, double val)` Assigns the specified double value to each element of the specified array of doubles.
`static void` | `fill(double[] a, int fromIndex, int toIndex, double val)` Assigns the specified double value to each element of the specified range of the specified array of doubles.
`static void` | `fill(float[] a, float val)` Assigns the specified float value to each element of the specified array of floats.
`static void` | `fill(float[] a, int fromIndex, int toIndex, float val)` Assigns the specified float value to each element of the specified range of the specified array of floats.
`static void` | `fill(int[] a, int val)` Assigns the specified int value to each element of the specified array of ints.
`static void` | `fill(int[] a, int fromIndex, int toIndex, int val)` Assigns the specified int value to each element of the specified range of the specified array of ints.
`static void` | `fill(long[] a, int fromIndex, int toIndex, long val)` Assigns the specified long value to each element of the specified range of the specified array of longs.
`static void` | `fill(long[] a, long val)` Assigns the specified long value to each element of the specified array of longs.
`static void` | `fill(Object[] a, int fromIndex, int toIndex, Object val)` Assigns the specified Object reference to each element of the specified range of the specified array of Objects.
`static void` | `fill(Object[] a, Object val)` Assigns the specified Object reference to each element of the specified array of Objects.
`static void` | `fill(short[] a, int fromIndex, int toIndex, short val)` Assigns the specified short value to each element of the specified range of the specified array of shorts.
`static void` | `fill(short[] a, short val)` Assigns the specified short value to each element of the specified array of shorts.
`static void` | `sort(byte[] a)` Sorts the specified array of bytes into ascending numerical order.
`static void` | `sort(byte[] a, int fromIndex, int toIndex)` Sorts the specified range of the specified array of bytes into ascending numerical order.
`static void` | `sort(char[] a)` Sorts the specified array of chars into ascending numerical order.
`static void` | `sort(char[] a, int fromIndex, int toIndex)` Sorts the specified range of the specified array of chars into ascending numerical order.
`static void` | `sort(double[] a)` Sorts the specified array of doubles into ascending numerical order.
`static void` | `sort(double[] a, int fromIndex, int toIndex)` Sorts the specified range of the specified array of doubles into ascending numerical order.
`static void` | `sort(float[] a)` Sorts the specified array of floats into ascending numerical order.
`static void` | `sort(float[] a, int fromIndex, int toIndex)` Sorts the specified range of the specified array of floats into ascending numerical order.
`static void` | `sort(int[] a)` Sorts the specified array of ints into ascending numerical order.
`static void` | `sort(int[] a, int fromIndex, int toIndex)` Sorts the specified range of the specified array of ints into ascending numerical order.
`static void` | `sort(long[] a)` Sorts the specified array of longs into ascending numerical order.
`static void` | `sort(long[] a, int fromIndex, int toIndex)` Sorts the specified range of the specified array of longs into ascending numerical order.
`static void` | `sort(Object[] a)` Sorts the specified array of objects into ascending order, according to the natural ordering of its elements.
`static void` | `sort(Object[] a, Comparator c)` Sorts the specified array of objects according to the order induced by the specified comparator.
`static void` | `sort(Object[] a, int fromIndex, int toIndex)` Sorts the specified range of the specified array of objects into ascending order, according to the natural ordering of its elements.
`static void` | `sort(Object[] a, int fromIndex, int toIndex, Comparator c)` Sorts the specified range of the specified array of objects according to the order induced by the specified comparator.
`static void` | `sort(short[] a)` Sorts the specified array of shorts into ascending numerical order.
`static void` | `sort(short[] a, int fromIndex, int toIndex)` Sorts the specified range of the specified array of shorts into ascending numerical order.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### sort

    public static void sort(long[] a)

  Sorts the specified array of longs into ascending numerical order. The sorting algorithm is a tuned quicksort, adapted from Jon L. Bentley and M. Douglas McIlroy's "Engineering a Sort Function", Software-Practice and Experience, Vol. 23(11) P. 1249-1265 (November 1993). This algorithm offers n*log(n) performance on many data sets that cause other quicksorts to degrade to quadratic performance.
  Parameters:
    `a` - the array to be sorted.

### sort

    public static void sort(long[] a,
                            int fromIndex,
                            int toIndex)

  Sorts the specified range of the specified array of longs into ascending numerical order. The range to be sorted extends from index `fromIndex`, inclusive, to index `toIndex`, exclusive. (If `fromIndex==toIndex`, the range to be sorted is empty.)

  The sorting algorithm is a tuned quicksort, adapted from Jon L. Bentley and M. Douglas McIlroy's "Engineering a Sort Function", Software-Practice and Experience, Vol. 23(11) P. 1249-1265 (November 1993). This algorithm offers n*log(n) performance on many data sets that cause other quicksorts to degrade to quadratic performance.

  Parameters:
    `a` - the array to be sorted.
    `fromIndex` - the index of the first element (inclusive) to be sorted.
    `toIndex` - the index of the last element (exclusive) to be sorted.
  Throws:
    `IllegalArgumentException` - if `fromIndex > toIndex`
    `ArrayIndexOutOfBoundsException` - if `fromIndex < 0` or `toIndex > a.length`

### sort

    public static void sort(int[] a)

  Sorts the specified array of ints into ascending numerical order. The sorting algorithm is a tuned quicksort, adapted from Jon L. Bentley and M. Douglas McIlroy's "Engineering a Sort Function", Software-Practice and Experience, Vol. 23(11) P. 1249-1265 (November 1993). This algorithm offers n*log(n) performance on many data sets that cause other quicksorts to degrade to quadratic performance.
  Parameters:
    `a` - the array to be sorted.

### sort

    public static void sort(int[] a,
                            int fromIndex,
                            int toIndex)

  Sorts the specified range of the specified array of ints into ascending numerical order. The range to be sorted extends from index `fromIndex`, inclusive, to index `toIndex`, exclusive. (If `fromIndex==toIndex`, the range to be sorted is empty.)

  The sorting algorithm is a tuned quicksort, adapted from Jon L. Bentley and M. Douglas McIlroy's "Engineering a Sort Function", Software-Practice and Experience, Vol. 23(11) P. 1249-1265 (November 1993). This algorithm offers n*log(n) performance on many data sets that cause other quicksorts to degrade to quadratic performance.

  Parameters:
    `a` - the array to be sorted.
    `fromIndex` - the index of the first element (inclusive) to be sorted.
    `toIndex` - the index of the last element (exclusive) to be sorted.
  Throws:
    `IllegalArgumentException` - if `fromIndex > toIndex`
    `ArrayIndexOutOfBoundsException` - if `fromIndex < 0` or `toIndex > a.length`

### sort

    public static void sort(short[] a)

  Sorts the specified array of shorts into ascending numerical order. The sorting algorithm is a tuned quicksort, adapted from Jon L. Bentley and M. Douglas McIlroy's "Engineering a Sort Function", Software-Practice and Experience, Vol. 23(11) P. 1249-1265 (November 1993). This algorithm offers n*log(n) performance on many data sets that cause other quicksorts to degrade to quadratic performance.
  Parameters:
    `a` - the array to be sorted.

### sort

    public static void sort(short[] a,
                            int fromIndex,
                            int toIndex)

  Sorts the specified range of the specified array of shorts into ascending numerical order. The range to be sorted extends from index `fromIndex`, inclusive, to index `toIndex`, exclusive. (If `fromIndex==toIndex`, the range to be sorted is empty.)

  The sorting algorithm is a tuned quicksort, adapted from Jon L. Bentley and M. Douglas McIlroy's "Engineering a Sort Function", Software-Practice and Experience, Vol. 23(11) P. 1249-1265 (November 1993). This algorithm offers n*log(n) performance on many data sets that cause other quicksorts to degrade to quadratic performance.

  Parameters:
    `a` - the array to be sorted.
    `fromIndex` - the index of the first element (inclusive) to be sorted.
    `toIndex` - the index of the last element (exclusive) to be sorted.
  Throws:
    `IllegalArgumentException` - if `fromIndex > toIndex`
    `ArrayIndexOutOfBoundsException` - if `fromIndex < 0` or `toIndex > a.length`

### sort

    public static void sort(char[] a)

  Sorts the specified array of chars into ascending numerical order. The sorting algorithm is a tuned quicksort, adapted from Jon L. Bentley and M. Douglas McIlroy's "Engineering a Sort Function", Software-Practice and Experience, Vol. 23(11) P. 1249-1265 (November 1993). This algorithm offers n*log(n) performance on many data sets that cause other quicksorts to degrade to quadratic performance.
  Parameters:
    `a` - the array to be sorted.

### sort

    public static void sort(char[] a,
                            int fromIndex,
                            int toIndex)

  Sorts the specified range of the specified array of chars into ascending numerical order. The range to be sorted extends from index `fromIndex`, inclusive, to index `toIndex`, exclusive. (If `fromIndex==toIndex`, the range to be sorted is empty.)

  The sorting algorithm is a tuned quicksort, adapted from Jon L. Bentley and M. Douglas McIlroy's "Engineering a Sort Function", Software-Practice and Experience, Vol. 23(11) P. 1249-1265 (November 1993). This algorithm offers n*log(n) performance on many data sets that cause other quicksorts to degrade to quadratic performance.

  Parameters:
    `a` - the array to be sorted.
    `fromIndex` - the index of the first element (inclusive) to be sorted.
    `toIndex` - the index of the last element (exclusive) to be sorted.
  Throws:
    `IllegalArgumentException` - if `fromIndex > toIndex`
    `ArrayIndexOutOfBoundsException` - if `fromIndex < 0` or `toIndex > a.length`

### sort

    public static void sort(byte[] a)

  Sorts the specified array of bytes into ascending numerical order. The sorting algorithm is a tuned quicksort, adapted from Jon L. Bentley and M. Douglas McIlroy's "Engineering a Sort Function", Software-Practice and Experience, Vol. 23(11) P. 1249-1265 (November 1993). This algorithm offers n*log(n) performance on many data sets that cause other quicksorts to degrade to quadratic performance.
  Parameters:
    `a` - the array to be sorted.

### sort

    public static void sort(byte[] a,
                            int fromIndex,
                            int toIndex)

  Sorts the specified range of the specified array of bytes into ascending numerical order. The range to be sorted extends from index `fromIndex`, inclusive, to index `toIndex`, exclusive. (If `fromIndex==toIndex`, the range to be sorted is empty.)

  The sorting algorithm is a tuned quicksort, adapted from Jon L. Bentley and M. Douglas McIlroy's "Engineering a Sort Function", Software-Practice and Experience, Vol. 23(11) P. 1249-1265 (November 1993). This algorithm offers n*log(n) performance on many data sets that cause other quicksorts to degrade to quadratic performance.

  Parameters:
    `a` - the array to be sorted.
    `fromIndex` - the index of the first element (inclusive) to be sorted.
    `toIndex` - the index of the last element (exclusive) to be sorted.
  Throws:
    `IllegalArgumentException` - if `fromIndex > toIndex`
    `ArrayIndexOutOfBoundsException` - if `fromIndex < 0` or `toIndex > a.length`

### sort

    public static void sort(double[] a)

  Sorts the specified array of doubles into ascending numerical order. The sorting algorithm is a tuned quicksort, adapted from Jon L. Bentley and M. Douglas McIlroy's "Engineering a Sort Function", Software-Practice and Experience, Vol. 23(11) P. 1249-1265 (November 1993). This algorithm offers n*log(n) performance on many data sets that cause other quicksorts to degrade to quadratic performance.
  Parameters:
    `a` - the array to be sorted.

### sort

    public static void sort(double[] a,
                            int fromIndex,
                            int toIndex)

  Sorts the specified range of the specified array of doubles into ascending numerical order. The range to be sorted extends from index `fromIndex`, inclusive, to index `toIndex`, exclusive. (If `fromIndex==toIndex`, the range to be sorted is empty.)

  The sorting algorithm is a tuned quicksort, adapted from Jon L. Bentley and M. Douglas McIlroy's "Engineering a Sort Function", Software-Practice and Experience, Vol. 23(11) P. 1249-1265 (November 1993). This algorithm offers n*log(n) performance on many data sets that cause other quicksorts to degrade to quadratic performance.

  Parameters:
    `a` - the array to be sorted.
    `fromIndex` - the index of the first element (inclusive) to be sorted.
    `toIndex` - the index of the last element (exclusive) to be sorted.
  Throws:
    `IllegalArgumentException` - if `fromIndex > toIndex`
    `ArrayIndexOutOfBoundsException` - if `fromIndex < 0` or `toIndex > a.length`

### sort

    public static void sort(float[] a)

  Sorts the specified array of floats into ascending numerical order. The sorting algorithm is a tuned quicksort, adapted from Jon L. Bentley and M. Douglas McIlroy's "Engineering a Sort Function", Software-Practice and Experience, Vol. 23(11) P. 1249-1265 (November 1993). This algorithm offers n*log(n) performance on many data sets that cause other quicksorts to degrade to quadratic performance.
  Parameters:
    `a` - the array to be sorted.

### sort

    public static void sort(float[] a,
                            int fromIndex,
                            int toIndex)

  Sorts the specified range of the specified array of floats into ascending numerical order. The range to be sorted extends from index `fromIndex`, inclusive, to index `toIndex`, exclusive. (If `fromIndex==toIndex`, the range to be sorted is empty.)

  The sorting algorithm is a tuned quicksort, adapted from Jon L. Bentley and M. Douglas McIlroy's "Engineering a Sort Function", Software-Practice and Experience, Vol. 23(11) P. 1249-1265 (November 1993). This algorithm offers n*log(n) performance on many data sets that cause other quicksorts to degrade to quadratic performance.

  Parameters:
    `a` - the array to be sorted.
    `fromIndex` - the index of the first element (inclusive) to be sorted.
    `toIndex` - the index of the last element (exclusive) to be sorted.
  Throws:
    `IllegalArgumentException` - if `fromIndex > toIndex`
    `ArrayIndexOutOfBoundsException` - if `fromIndex < 0` or `toIndex > a.length`

### sort

    public static void sort(Object[] a)

  Sorts the specified array of objects into ascending order, according to the natural ordering of its elements. All elements in the array must implement the `Comparable` interface. Furthermore, all elements in the array must be mutually comparable (that is, `e1.compareTo(e2)` must not throw a `ClassCastException` for any elements `e1` and `e2` in the array).

  This sort is guaranteed to be stable: equal elements will not be reordered as a result of the sort.

  The sorting algorithm is a modified mergesort (in which the merge is omitted if the highest element in the low sublist is less than the lowest element in the high sublist). This algorithm offers guaranteed n*log(n) performance, and can approach linear performance on nearly sorted lists.

  Parameters:
    `a` - the array to be sorted.
  Throws:
    `ClassCastException` - if the array contains elements that are not mutually comparable (for example, strings and integers).
  See Also:
    `Comparable`

### sort

    public static void sort(Object[] a,
                            int fromIndex,
                            int toIndex)

  Sorts the specified range of the specified array of objects into ascending order, according to the natural ordering of its elements. The range to be sorted extends from index `fromIndex`, inclusive, to index `toIndex`, exclusive. (If `fromIndex==toIndex`, the range to be sorted is empty.) All elements in this range must implement the `Comparable` interface. Furthermore, all elements in this range must be mutually comparable (that is, `e1.compareTo(e2)` must not throw a `ClassCastException` for any elements `e1` and `e2` in the array).

  This sort is guaranteed to be stable: equal elements will not be reordered as a result of the sort.

  The sorting algorithm is a modified mergesort (in which the merge is omitted if the highest element in the low sublist is less than the lowest element in the high sublist). This algorithm offers guaranteed n*log(n) performance, and can approach linear performance on nearly sorted lists.

  Parameters:
    `a` - the array to be sorted.
    `fromIndex` - the index of the first element (inclusive) to be sorted.
    `toIndex` - the index of the last element (exclusive) to be sorted.
  Throws:
    `IllegalArgumentException` - if `fromIndex > toIndex`
    `ArrayIndexOutOfBoundsException` - if `fromIndex < 0` or `toIndex > a.length`
    `ClassCastException` - if the array contains elements that are not mutually comparable (for example, strings and integers).
  See Also:
    `Comparable`

### sort

    public static void sort(Object[] a,
                            Comparator c)

  Sorts the specified array of objects according to the order induced by the specified comparator. All elements in the array must be mutually comparable by the specified comparator (that is, `c.compare(e1, e2)` must not throw a `ClassCastException` for any elements `e1` and `e2` in the array).

  This sort is guaranteed to be stable: equal elements will not be reordered as a result of the sort.

  The sorting algorithm is a modified mergesort (in which the merge is omitted if the highest element in the low sublist is less than the lowest element in the high sublist). This algorithm offers guaranteed n*log(n) performance, and can approach linear performance on nearly sorted lists.

  Parameters:
    `a` - the array to be sorted.
    `c` - the comparator to determine the order of the array. A `null` value indicates that the elements' natural ordering should be used.
  Throws:
    `ClassCastException` - if the array contains elements that are not mutually comparable using the specified comparator.
  See Also:
    `Comparator`

### sort

    public static void sort(Object[] a,
                            int fromIndex,
                            int toIndex,
                            Comparator c)

  Sorts the specified range of the specified array of objects according to the order induced by the specified comparator. The range to be sorted extends from index `fromIndex`, inclusive, to index `toIndex`, exclusive. (If `fromIndex==toIndex`, the range to be sorted is empty.) All elements in the range must be mutually comparable by the specified comparator (that is, `c.compare(e1, e2)` must not throw a `ClassCastException` for any elements `e1` and `e2` in the range).

  This sort is guaranteed to be stable: equal elements will not be reordered as a result of the sort.

  The sorting algorithm is a modified mergesort (in which the merge is omitted if the highest element in the low sublist is less than the lowest element in the high sublist). This algorithm offers guaranteed n*log(n) performance, and can approach linear performance on nearly sorted lists.

  Parameters:
    `a` - the array to be sorted.
    `fromIndex` - the index of the first element (inclusive) to be sorted.
    `toIndex` - the index of the last element (exclusive) to be sorted.
    `c` - the comparator to determine the order of the array. A `null` value indicates that the elements' natural ordering should be used.
  Throws:
    `ClassCastException` - if the array contains elements that are not mutually comparable using the specified comparator.
    `IllegalArgumentException` - if `fromIndex > toIndex`
    `ArrayIndexOutOfBoundsException` - if `fromIndex < 0` or `toIndex > a.length`
  See Also:
    `Comparator`

### binarySearch

    public static int binarySearch(long[] a,
                                   long key)

  Searches the specified array of longs for the specified value using the binary search algorithm. The array must be sorted (as by the `sort` method, above) prior to making this call. If it is not sorted, the results are undefined. If the array contains multiple elements with the specified value, there is no guarantee which one will be found.
  Parameters:
    `a` - the array to be searched.
    `key` - the value to be searched for.
  Returns:
    index of the search key, if it is contained in the list; otherwise, `(-(insertion point) - 1)`. The insertion point is defined as the point at which the key would be inserted into the list: the index of the first element greater than the key, or `list.size()`, if all elements in the list are less than the specified key. Note that this guarantees that the return value will be >= 0 if and only if the key is found.
  See Also:
    `sort(long[])`

### binarySearch

    public static int binarySearch(int[] a,
                                   int key)

  Searches the specified array of ints for the specified value using the binary search algorithm. The array must be sorted (as by the `sort` method, above) prior to making this call. If it is not sorted, the results are undefined. If the array contains multiple elements with the specified value, there is no guarantee which one will be found.
  Parameters:
    `a` - the array to be searched.
    `key` - the value to be searched for.
  Returns:
    index of the search key, if it is contained in the list; otherwise, `(-(insertion point) - 1)`. The insertion point is defined as the point at which the key would be inserted into the list: the index of the first element greater than the key, or `list.size()`, if all elements in the list are less than the specified key. Note that this guarantees that the return value will be >= 0 if and only if the key is found.
  See Also:
    `sort(int[])`

### binarySearch

    public static int binarySearch(short[] a,
                                   short key)

  Searches the specified array of shorts for the specified value using the binary search algorithm. The array must be sorted (as by the `sort` method, above) prior to making this call. If it is not sorted, the results are undefined. If the array contains multiple elements with the specified value, there is no guarantee which one will be found.
  Parameters:
    `a` - the array to be searched.
    `key` - the value to be searched for.
  Returns:
    index of the search key, if it is contained in the list; otherwise, `(-(insertion point) - 1)`. The insertion point is defined as the point at which the key would be inserted into the list: the index of the first element greater than the key, or `list.size()`, if all elements in the list are less than the specified key. Note that this guarantees that the return value will be >= 0 if and only if the key is found.
  See Also:
    `sort(short[])`

### binarySearch

    public static int binarySearch(char[] a,
                                   char key)

  Searches the specified array of chars for the specified value using the binary search algorithm. The array must be sorted (as by the `sort` method, above) prior to making this call. If it is not sorted, the results are undefined. If the array contains multiple elements with the specified value, there is no guarantee which one will be found.
  Parameters:
    `a` - the array to be searched.
    `key` - the value to be searched for.
  Returns:
    index of the search key, if it is contained in the list; otherwise, `(-(insertion point) - 1)`. The insertion point is defined as the point at which the key would be inserted into the list: the index of the first element greater than the key, or `list.size()`, if all elements in the list are less than the specified key. Note that this guarantees that the return value will be >= 0 if and only if the key is found.
  See Also:
    `sort(char[])`

### binarySearch

    public static int binarySearch(byte[] a,
                                   byte key)

  Searches the specified array of bytes for the specified value using the binary search algorithm. The array must be sorted (as by the `sort` method, above) prior to making this call. If it is not sorted, the results are undefined. If the array contains multiple elements with the specified value, there is no guarantee which one will be found.
  Parameters:
    `a` - the array to be searched.
    `key` - the value to be searched for.
  Returns:
    index of the search key, if it is contained in the list; otherwise, `(-(insertion point) - 1)`. The insertion point is defined as the point at which the key would be inserted into the list: the index of the first element greater than the key, or `list.size()`, if all elements in the list are less than the specified key. Note that this guarantees that the return value will be >= 0 if and only if the key is found.
  See Also:
    `sort(byte[])`

### binarySearch

    public static int binarySearch(double[] a,
                                   double key)

  Searches the specified array of doubles for the specified value using the binary search algorithm. The array must be sorted (as by the `sort` method, above) prior to making this call. If it is not sorted, the results are undefined. If the array contains multiple elements with the specified value, there is no guarantee which one will be found.
  Parameters:
    `a` - the array to be searched.
    `key` - the value to be searched for.
  Returns:
    index of the search key, if it is contained in the list; otherwise, `(-(insertion point) - 1)`. The insertion point is defined as the point at which the key would be inserted into the list: the index of the first element greater than the key, or `list.size()`, if all elements in the list are less than the specified key. Note that this guarantees that the return value will be >= 0 if and only if the key is found.
  See Also:
    `sort(double[])`

### binarySearch

    public static int binarySearch(float[] a,
                                   float key)

  Searches the specified array of floats for the specified value using the binary search algorithm. The array must be sorted (as by the `sort` method, above) prior to making this call. If it is not sorted, the results are undefined. If the array contains multiple elements with the specified value, there is no guarantee which one will be found.
  Parameters:
    `a` - the array to be searched.
    `key` - the value to be searched for.
  Returns:
    index of the search key, if it is contained in the list; otherwise, `(-(insertion point) - 1)`. The insertion point is defined as the point at which the key would be inserted into the list: the index of the first element greater than the key, or `list.size()`, if all elements in the list are less than the specified key. Note that this guarantees that the return value will be >= 0 if and only if the key is found.
  See Also:
    `sort(float[])`

### binarySearch

    public static int binarySearch(Object[] a,
                                   Object key)

  Searches the specified array for the specified object using the binary search algorithm. The array must be sorted into ascending order according to the natural ordering of its elements (as by `Sort(Object[]`), above) prior to making this call. If it is not sorted, the results are undefined. If the array contains multiple elements equal to the specified object, there is no guarantee which one will be found.
  Parameters:
    `a` - the array to be searched.
    `key` - the value to be searched for.
  Returns:
    index of the search key, if it is contained in the list; otherwise, `(-(insertion point) - 1)`. The insertion point is defined as the point at which the key would be inserted into the list: the index of the first element greater than the key, or `list.size()`, if all elements in the list are less than the specified key. Note that this guarantees that the return value will be >= 0 if and only if the key is found.
  Throws:
    `ClassCastException` - if the array contains elements that are not mutually comparable (for example, strings and integers), or the search key in not mutually comparable with the elements of the array.
  See Also:
    `Comparable`, `sort(Object[])`

### binarySearch

    public static int binarySearch(Object[] a,
                                   Object key,
                                   Comparator c)

  Searches the specified array for the specified object using the binary search algorithm. The array must be sorted into ascending order according to the specified comparator (as by the `Sort(Object[], Comparator)` method, above), prior to making this call. If it is not sorted, the results are undefined. If the array contains multiple elements equal to the specified object, there is no guarantee which one will be found.
  Parameters:
    `a` - the array to be searched.
    `key` - the value to be searched for.
    `c` - the comparator by which the array is ordered. A `null` value indicates that the elements' natural ordering should be used.
  Returns:
    index of the search key, if it is contained in the list; otherwise, `(-(insertion point) - 1)`. The insertion point is defined as the point at which the key would be inserted into the list: the index of the first element greater than the key, or `list.size()`, if all elements in the list are less than the specified key. Note that this guarantees that the return value will be >= 0 if and only if the key is found.
  Throws:
    `ClassCastException` - if the array contains elements that are not mutually comparable using the specified comparator, or the search key in not mutually comparable with the elements of the array using this comparator.
  See Also:
    `Comparable`, `sort(Object[], Comparator)`

### equals

    public static boolean equals(long[] a,
                                 long[] a2)

  Returns `true` if the two specified arrays of longs are equal to one another. Two arrays are considered equal if both arrays contain the same number of elements, and all corresponding pairs of elements in the two arrays are equal. In other words, two arrays are equal if they contain the same elements in the same order. Also, two array references are considered equal if both are `null`.

  Parameters:
    `a` - one array to be tested for equality.
    `a2` - the other array to be tested for equality.
  Returns:
    `true` if the two arrays are equal.

### equals

    public static boolean equals(int[] a,
                                 int[] a2)

  Returns `true` if the two specified arrays of ints are equal to one another. Two arrays are considered equal if both arrays contain the same number of elements, and all corresponding pairs of elements in the two arrays are equal. In other words, two arrays are equal if they contain the same elements in the same order. Also, two array references are considered equal if both are `null`.

  Parameters:
    `a` - one array to be tested for equality.
    `a2` - the other array to be tested for equality.
  Returns:
    `true` if the two arrays are equal.

### equals

    public static boolean equals(short[] a,
                                 short[] a2)

  Returns `true` if the two specified arrays of shorts are equal to one another. Two arrays are considered equal if both arrays contain the same number of elements, and all corresponding pairs of elements in the two arrays are equal. In other words, two arrays are equal if they contain the same elements in the same order. Also, two array references are considered equal if both are `null`.

  Parameters:
    `a` - one array to be tested for equality.
    `a2` - the other array to be tested for equality.
  Returns:
    `true` if the two arrays are equal.

### equals

    public static boolean equals(char[] a,
                                 char[] a2)

  Returns `true` if the two specified arrays of chars are equal to one another. Two arrays are considered equal if both arrays contain the same number of elements, and all corresponding pairs of elements in the two arrays are equal. In other words, two arrays are equal if they contain the same elements in the same order. Also, two array references are considered equal if both are `null`.

  Parameters:
    `a` - one array to be tested for equality.
    `a2` - the other array to be tested for equality.
  Returns:
    `true` if the two arrays are equal.

### equals

    public static boolean equals(byte[] a,
                                 byte[] a2)

  Returns `true` if the two specified arrays of bytes are equal to one another. Two arrays are considered equal if both arrays contain the same number of elements, and all corresponding pairs of elements in the two arrays are equal. In other words, two arrays are equal if they contain the same elements in the same order. Also, two array references are considered equal if both are `null`.

  Parameters:
    `a` - one array to be tested for equality.
    `a2` - the other array to be tested for equality.
  Returns:
    `true` if the two arrays are equal.

### equals

    public static boolean equals(boolean[] a,
                                 boolean[] a2)

  Returns `true` if the two specified arrays of equals are equal to one another. Two arrays are considered equal if both arrays contain the same number of elements, and all corresponding pairs of elements in the two arrays are equal. In other words, two arrays are equal if they contain the same elements in the same order. Also, two array references are considered equal if both are `null`.

  Parameters:
    `a` - one array to be tested for equality.
    `a2` - the other array to be tested for equality.
  Returns:
    `true` if the two arrays are equal.

### equals

    public static boolean equals(double[] a,
                                 double[] a2)

  Returns `true` if the two specified arrays of doubles are equal to one another. Two arrays are considered equal if both arrays contain the same number of elements, and all corresponding pairs of elements in the two arrays are equal. In other words, two arrays are equal if they contain the same elements in the same order. Also, two array references are considered equal if both are `null`.

  Two doubles `d1` and `d2` are considered equal if:

          new Double(d1).equals(new Double(d2))

  (Unlike the `==` operator, this method considers `NaN` equals to itself, and 0.0d unequal to -0.0d.)
  Parameters:
    `a` - one array to be tested for equality.
    `a2` - the other array to be tested for equality.
  Returns:
    `true` if the two arrays are equal.
  See Also:
    `Double.equals(Object)`

### equals

    public static boolean equals(float[] a,
                                 float[] a2)

  Returns `true` if the two specified arrays of floats are equal to one another. Two arrays are considered equal if both arrays contain the same number of elements, and all corresponding pairs of elements in the two arrays are equal. In other words, two arrays are equal if they contain the same elements in the same order. Also, two array references are considered equal if both are `null`.

  Two floats `f1` and `f2` are considered equal if:

          new Float(f1).equals(new Float(f2))

  (Unlike the `==` operator, this method considers `NaN` equals to itself, and 0.0f unequal to -0.0f.)
  Parameters:
    `a` - one array to be tested for equality.
    `a2` - the other array to be tested for equality.
  Returns:
    `true` if the two arrays are equal.
  See Also:
    `Float.equals(Object)`

### equals

    public static boolean equals(Object[] a,
                                 Object[] a2)

  Returns `true` if the two specified arrays of Objects are equal to one another. The two arrays are considered equal if both arrays contain the same number of elements, and all corresponding pairs of elements in the two arrays are equal. Two objects `e1` and `e2` are considered equal if `(e1==null ? e2==null : e1.equals(e2))`. In other words, the two arrays are equal if they contain the same elements in the same order. Also, two array references are considered equal if both are `null`.

  Parameters:
    `a` - one array to be tested for equality.
    `a2` - the other array to be tested for equality.
  Returns:
    `true` if the two arrays are equal.

### fill

    public static void fill(long[] a,
                            long val)

  Assigns the specified long value to each element of the specified array of longs.
  Parameters:
    `a` - the array to be filled.
    `val` - the value to be stored in all elements of the array.

### fill

    public static void fill(long[] a,
                            int fromIndex,
                            int toIndex,
                            long val)

  Assigns the specified long value to each element of the specified range of the specified array of longs. The range to be filled extends from index `fromIndex`, inclusive, to index `toIndex`, exclusive. (If `fromIndex==toIndex`, the range to be filled is empty.)
  Parameters:
    `a` - the array to be filled.
    `fromIndex` - the index of the first element (inclusive) to be filled with the specified value.
    `toIndex` - the index of the last element (exclusive) to be filled with the specified value.
    `val` - the value to be stored in all elements of the array.
  Throws:
    `IllegalArgumentException` - if `fromIndex > toIndex`
    `ArrayIndexOutOfBoundsException` - if `fromIndex < 0` or `toIndex > a.length`

### fill

    public static void fill(int[] a,
                            int val)

  Assigns the specified int value to each element of the specified array of ints.
  Parameters:
    `a` - the array to be filled.
    `val` - the value to be stored in all elements of the array.

### fill

    public static void fill(int[] a,
                            int fromIndex,
                            int toIndex,
                            int val)

  Assigns the specified int value to each element of the specified range of the specified array of ints. The range to be filled extends from index `fromIndex`, inclusive, to index `toIndex`, exclusive. (If `fromIndex==toIndex`, the range to be filled is empty.)
  Parameters:
    `a` - the array to be filled.
    `fromIndex` - the index of the first element (inclusive) to be filled with the specified value.
    `toIndex` - the index of the last element (exclusive) to be filled with the specified value.
    `val` - the value to be stored in all elements of the array.
  Throws:
    `IllegalArgumentException` - if `fromIndex > toIndex`
    `ArrayIndexOutOfBoundsException` - if `fromIndex < 0` or `toIndex > a.length`

### fill

    public static void fill(short[] a,
                            short val)

  Assigns the specified short value to each element of the specified array of shorts.
  Parameters:
    `a` - the array to be filled.
    `val` - the value to be stored in all elements of the array.

### fill

    public static void fill(short[] a,
                            int fromIndex,
                            int toIndex,
                            short val)

  Assigns the specified short value to each element of the specified range of the specified array of shorts. The range to be filled extends from index `fromIndex`, inclusive, to index `toIndex`, exclusive. (If `fromIndex==toIndex`, the range to be filled is empty.)
  Parameters:
    `a` - the array to be filled.
    `fromIndex` - the index of the first element (inclusive) to be filled with the specified value.
    `toIndex` - the index of the last element (exclusive) to be filled with the specified value.
    `val` - the value to be stored in all elements of the array.
  Throws:
    `IllegalArgumentException` - if `fromIndex > toIndex`
    `ArrayIndexOutOfBoundsException` - if `fromIndex < 0` or `toIndex > a.length`

### fill

    public static void fill(char[] a,
                            char val)

  Assigns the specified char value to each element of the specified array of chars.
  Parameters:
    `a` - the array to be filled.
    `val` - the value to be stored in all elements of the array.

### fill

    public static void fill(char[] a,
                            int fromIndex,
                            int toIndex,
                            char val)

  Assigns the specified char value to each element of the specified range of the specified array of chars. The range to be filled extends from index `fromIndex`, inclusive, to index `toIndex`, exclusive. (If `fromIndex==toIndex`, the range to be filled is empty.)
  Parameters:
    `a` - the array to be filled.
    `fromIndex` - the index of the first element (inclusive) to be filled with the specified value.
    `toIndex` - the index of the last element (exclusive) to be filled with the specified value.
    `val` - the value to be stored in all elements of the array.
  Throws:
    `IllegalArgumentException` - if `fromIndex > toIndex`
    `ArrayIndexOutOfBoundsException` - if `fromIndex < 0` or `toIndex > a.length`

### fill

    public static void fill(byte[] a,
                            byte val)

  Assigns the specified byte value to each element of the specified array of bytes.
  Parameters:
    `a` - the array to be filled.
    `val` - the value to be stored in all elements of the array.

### fill

    public static void fill(byte[] a,
                            int fromIndex,
                            int toIndex,
                            byte val)

  Assigns the specified byte value to each element of the specified range of the specified array of bytes. The range to be filled extends from index `fromIndex`, inclusive, to index `toIndex`, exclusive. (If `fromIndex==toIndex`, the range to be filled is empty.)
  Parameters:
    `a` - the array to be filled.
    `fromIndex` - the index of the first element (inclusive) to be filled with the specified value.
    `toIndex` - the index of the last element (exclusive) to be filled with the specified value.
    `val` - the value to be stored in all elements of the array.
  Throws:
    `IllegalArgumentException` - if `fromIndex > toIndex`
    `ArrayIndexOutOfBoundsException` - if `fromIndex < 0` or `toIndex > a.length`

### fill

    public static void fill(boolean[] a,
                            boolean val)

  Assigns the specified boolean value to each element of the specified array of booleans.
  Parameters:
    `a` - the array to be filled.
    `val` - the value to be stored in all elements of the array.

### fill

    public static void fill(boolean[] a,
                            int fromIndex,
                            int toIndex,
                            boolean val)

  Assigns the specified boolean value to each element of the specified range of the specified array of booleans. The range to be filled extends from index `fromIndex`, inclusive, to index `toIndex`, exclusive. (If `fromIndex==toIndex`, the range to be filled is empty.)
  Parameters:
    `a` - the array to be filled.
    `fromIndex` - the index of the first element (inclusive) to be filled with the specified value.
    `toIndex` - the index of the last element (exclusive) to be filled with the specified value.
    `val` - the value to be stored in all elements of the array.
  Throws:
    `IllegalArgumentException` - if `fromIndex > toIndex`
    `ArrayIndexOutOfBoundsException` - if `fromIndex < 0` or `toIndex > a.length`

### fill

    public static void fill(double[] a,
                            double val)

  Assigns the specified double value to each element of the specified array of doubles.
  Parameters:
    `a` - the array to be filled.
    `val` - the value to be stored in all elements of the array.

### fill

    public static void fill(double[] a,
                            int fromIndex,
                            int toIndex,
                            double val)

  Assigns the specified double value to each element of the specified range of the specified array of doubles. The range to be filled extends from index `fromIndex`, inclusive, to index `toIndex`, exclusive. (If `fromIndex==toIndex`, the range to be filled is empty.)
  Parameters:
    `a` - the array to be filled.
    `fromIndex` - the index of the first element (inclusive) to be filled with the specified value.
    `toIndex` - the index of the last element (exclusive) to be filled with the specified value.
    `val` - the value to be stored in all elements of the array.
  Throws:
    `IllegalArgumentException` - if `fromIndex > toIndex`
    `ArrayIndexOutOfBoundsException` - if `fromIndex < 0` or `toIndex > a.length`

### fill

    public static void fill(float[] a,
                            float val)

  Assigns the specified float value to each element of the specified array of floats.
  Parameters:
    `a` - the array to be filled.
    `val` - the value to be stored in all elements of the array.

### fill

    public static void fill(float[] a,
                            int fromIndex,
                            int toIndex,
                            float val)

  Assigns the specified float value to each element of the specified range of the specified array of floats. The range to be filled extends from index `fromIndex`, inclusive, to index `toIndex`, exclusive. (If `fromIndex==toIndex`, the range to be filled is empty.)
  Parameters:
    `a` - the array to be filled.
    `fromIndex` - the index of the first element (inclusive) to be filled with the specified value.
    `toIndex` - the index of the last element (exclusive) to be filled with the specified value.
    `val` - the value to be stored in all elements of the array.
  Throws:
    `IllegalArgumentException` - if `fromIndex > toIndex`
    `ArrayIndexOutOfBoundsException` - if `fromIndex < 0` or `toIndex > a.length`

### fill

    public static void fill(Object[] a,
                            Object val)

  Assigns the specified Object reference to each element of the specified array of Objects.
  Parameters:
    `a` - the array to be filled.
    `val` - the value to be stored in all elements of the array.

### fill

    public static void fill(Object[] a,
                            int fromIndex,
                            int toIndex,
                            Object val)

  Assigns the specified Object reference to each element of the specified range of the specified array of Objects. The range to be filled extends from index `fromIndex`, inclusive, to index `toIndex`, exclusive. (If `fromIndex==toIndex`, the range to be filled is empty.)
  Parameters:
    `a` - the array to be filled.
    `fromIndex` - the index of the first element (inclusive) to be filled with the specified value.
    `toIndex` - the index of the last element (exclusive) to be filled with the specified value.
    `val` - the value to be stored in all elements of the array.
  Throws:
    `IllegalArgumentException` - if `fromIndex > toIndex`
    `ArrayIndexOutOfBoundsException` - if `fromIndex < 0` or `toIndex > a.length`

### asList

    public static List asList(Object[] a)

  Returns a fixed-size list backed by the specified array. (Changes to the returned list "write through" to the array.) This method acts as bridge between array-based and collection-based APIs, in combination with `Collection.toArray`. The returned list is serializable.
  Parameters:
    `a` - the array by which the list will be backed.
  Returns:
    a list view of the specified array.
  See Also:
    `Collection.toArray()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.